# Kompilacja w środowisku NixOS

NixOS jest systemem operacyjnym, który pozwala na deklaratywne opisywanie środowiska. W tym rozdziale opisane są kroki potrzebne do zbudowania środowiska, w którym można budować usługi w chmurze.

W tym tutorialu została wykorzystana wersja NixOS 23.05.

Skrypt wykonujący dostępny w [01-build-nixos.sh](01-build-nixos.sh) wykonuje wszystkie kroki opisane w tym rozdziale.

## Wymagania

Chęć do zainstalowania NixOSa, bare metal lub wirtualnie. Wirtualizacja może być wykonana np. za pomocą [VirtualBox](https://www.virtualbox.org/).

## Kroki

Pobierz system NixOS z [nixos.org](https://nixos.org/download.html#nixos-iso) i zainstaluj go na swojej maszynie.

Potrzebujemy zainstalować pakiet `git` i sklonować repozytorium z kodem źródłowym usług w chmurze. W terminalu wpisujemy:

```bash
nix-env -iA nixos.git
git clone https://code.hackerspace.pl/hswaw/hscloud
cd hscloud
```

Ze względu na drobny błąd, należy pozbyć się z `shell.nix` komendy kompilacji `clang`:

```bash
sed -i '/gcc binutils clang/s/clang//g' "shell.nix"
```

Następny krok: [Budowa środowiska](02-build-environment.md)