# Kompilacja w środowisku Ubuntu

W tym rozdziale opisane są kroki potrzebne do zbudowania środowiska, w którym można budować usługi w chmurze hscloud. Instrukcja wzoruje się na [01-build-nixos.md](01-build-nixos.md), jedynie z dodatkowym krokiem pobierania i instalacji menedżera pakietów `nix`.

## Wymagania

Uprawnienia administratora, środowisko Ubuntu 22.04 lub nowsze, bądź odpowiedni Ubuntu-like desktop.

## Kroki

Instalujemy pakiety `git` oraz `curl`:

```bash
sudo apt install git curl
```

Pobieramy i instalujemy menadżer pakietów `nix` (źródło: [nixos.org](https://nixos.org/download)):

```bash
sh <(curl -L https://nixos.org/nix/install) --daemon
```

Po tej operacji należy wylogować się i zalogować ponownie, aby móc korzystać z `nix`.

```bash
reboot # overkill, ale pewne
```

Klonujemy repozytorium z kodem źródłowym usług w chmurze:

```bash
git clone https://code.hackerspace.pl/hswaw/hscloud
cd hscloud
```

Następny krok: [Budowa środowiska](02-build-environment.md)